import { UNDERPASS, GROUND } from '../constants';
import { getUnderpassNeighbouringNets } from '../query/getNeighbouringNets';
import insertItem from './insertItem';
export default function drawUnderpass(forest, x, y) {
    const buddyTree = forest.buddyTree;
    const neighbouringNets = getUnderpassNeighbouringNets(forest.enneaTree, x, y);
    if (neighbouringNets.horizontal.length > 1 || neighbouringNets.vertical.length > 1) {
        return forest;
    }
    const net = neighbouringNets.horizontal[0] || GROUND;
    const data = {
        type: UNDERPASS,
        net
    };
    const box = { left: x, top: y };
    return insertItem(forest, buddyTree, data, box);
}
//# sourceMappingURL=drawUnderpass.js.map