import { WIRE, GROUND } from '../constants';
import { getWireNeighbouringNets } from '../query/getNeighbouringNets';
import insertItem from './insertItem';
export default function drawWire(forest, x, y) {
    const buddyTree = forest.buddyTree;
    const neighbouringNets = getWireNeighbouringNets(forest.enneaTree, x, y);
    if (neighbouringNets.length > 1) {
        return forest;
    }
    const net = neighbouringNets[0] || GROUND;
    const data = makeWire(net);
    const box = { left: x, top: y };
    return insertItem(forest, buddyTree, data, box);
}
export const makeWire = (net) => ({
    type: WIRE,
    net
});
//# sourceMappingURL=drawWire.js.map