import { UPWARDS, LEFTWARDS, RIGHTWARDS, DOWNWARDS } from '../constants';
export default function light(oldLight, pos, ctx, queue) {
    const net = ctx.net;
    if (net === oldLight.net) {
        return oldLight;
    }
    const x = pos.left;
    const y = pos.top;
    const dx = ctx.pos.left - ctx.prev.left;
    const dy = ctx.pos.top - ctx.prev.top;
    switch (oldLight.direction) {
        case UPWARDS:
            return (x === 1 && y === 2 && dx === 0 && dy === -1)
                ? Object.assign({}, oldLight, { net }) : oldLight;
        case DOWNWARDS:
            return (x === 1 && y === 0 && dx === 0 && dy === 1)
                ? Object.assign({}, oldLight, { net }) : oldLight;
        case LEFTWARDS:
            return (x === 2 && y === 1 && dx === -1 && dy === 0)
                ? Object.assign({}, oldLight, { net }) : oldLight;
        case RIGHTWARDS:
        default:
            return (x === 0 && y === 1 && dx === 1 && dy === 0)
                ? Object.assign({}, oldLight, { net }) : oldLight;
    }
}
//# sourceMappingURL=light.js.map