import { WIRE, GATE, UNDERPASS, BUTTON, COMPONENT, LIGHT } from '../constants';
export default function unchanged(before, after) {
    switch (before.type) {
        case WIRE: return wire(before, after);
        case GATE: return gate(before, after);
        case UNDERPASS: return underpass(before, after);
        case BUTTON: return button(before, after);
        case COMPONENT: return component(before, after);
        case LIGHT: return light(before, after);
    }
}
function wire(before, after) {
    return before.net === after.net;
}
function gate(before, after) {
    return before.inputA === after.inputA
        && before.inputB === after.inputB
        && before.net === after.net;
}
function underpass(before, after) {
    return before.net === after.net;
}
function button(before, after) {
    return before.net === after.net
        && before.direction === after.direction
        && before.name === after.name;
}
function light(before, after) {
    return before.net === after.net
        && before.direction === after.direction
        && before.name === after.name;
}
function component(before, after) {
    if (before.package.name !== after.package.name)
        return false;
    if (before.package.hash !== after.package.hash)
        return false;
    if (before.inputs !== after.inputs && !before.inputs.every((e, i) => e.net === after.inputs[i].net))
        return false;
    return true;
}
//# sourceMappingURL=unchanged.js.map