import { GROUND } from '../constants';
import getNetAt from './getNetAt';
export function getWireNeighbouringNets(enneaTree, x, y) {
    return unique(getLeftRightNet(enneaTree, x, y), getAboveBelowNet(enneaTree, x, y));
}
export function getGateNeighbouringNets(enneaTree, x, y) {
    return unique(getRightNet(enneaTree, x, y));
}
export function getUnderpassNeighbouringNets(enneaTree, x, y) {
    return {
        horizontal: unique(getLeftRightNet(enneaTree, x, y)),
        vertical: unique(getAboveBelowNet(enneaTree, x, y))
    };
}
export function getButtonNeighbouringNets(enneaTree, x, y, dx, dy) {
    return getNetAt(enneaTree, x + dx * 2, y + dy * 2, dx, dy);
}
export function getLightNeighbouringNet(enneaTree, x, y, dx, dy) {
    return getNetAt(enneaTree, x - dx * 2, y - dy * 2, -dx, -dy);
}
function unique(...iteratorA) {
    return iteratorA
        .reduce((a, b) => a.concat(...b), [])
        .filter(net => net != GROUND)
        .filter((net, index, nets) => nets.indexOf(net) === index);
}
function* getLeftRightNet(enneaTree, x, y) {
    yield getNetAt(enneaTree, x - 1, y + 0, -1, 0);
    yield getNetAt(enneaTree, x + 1, y + 0, +1, 0);
}
function* getAboveBelowNet(enneaTree, x, y) {
    yield getNetAt(enneaTree, x + 0, y - 1, 0, -1);
    yield getNetAt(enneaTree, x + 0, y + 1, 0, +1);
}
function* getRightNet(enneaTree, x, y) {
    yield getNetAt(enneaTree, x + 1, y + 0, +1, 0);
}
//# sourceMappingURL=getNeighbouringNets.js.map