import { EMPTY_TILE } from './tileConstants';
import { WIRE, GATE, UNDERPASS, BUTTON, COMPONENT, GROUND } from '../constants';
export default function clear(context, change) {
    clearArea(context, change);
    switch (change.before.type) {
        case WIRE:
        case UNDERPASS:
            return;
        case GATE:
        case BUTTON:
            return clearGate(context, change.before);
        case COMPONENT:
            return clearComponent(context, change.before);
    }
}
export function clearArea(context, { top, left, width, height }) {
    for (let y = top; y < top + height; y++) {
        for (let x = left; x < left + width; x++) {
            context.setMap(x, y, EMPTY_TILE);
            context.setNet(x, y, GROUND);
        }
    }
}
export function clearGate(context, item) {
    context.clearGate(item.net);
}
export function clearComponent(context, component) {
    context.removeText(component);
    for (const index of component.package.gates.map((_, index) => index)) {
        context.clearGate(component.net + index);
    }
}
//# sourceMappingURL=clear.js.map