import { SET, UPDATE, CLEAR } from 'ennea-tree';
import set from './set';
import update from './update';
import clear from './clear';
export default function reconcile(context, changes) {
    let changed = false;
    for (const change of changes) {
        changed = true;
        reconcileChange(context, change);
    }
    return changed;
}
export function reconcileChange(context, change) {
    switch (change.type) {
        case SET:
            return set(context, change);
        case CLEAR:
            return clear(context, change);
        case UPDATE:
            if (change.before.type === change.after.type) {
                return update(context, change);
            }
            else {
                clear(context, Object.assign({}, change, { type: CLEAR }));
                set(context, Object.assign({}, change, { type: SET }));
            }
    }
}
//# sourceMappingURL=reconcile.js.map