import { Component } from '../types';
export interface Component0 {
    type: 'component';
    schema?: undefined;
    inputs: ComponentInput0[];
    outputs: ComponentOutput0[];
    gates: ComponentGate1[];
    nets: number[];
    hash: string;
    repo: string;
    name?: string;
    version: string;
}
export interface Component1 {
    type: 'component';
    schema: 1;
    inputs: ComponentInput0[];
    outputs: ComponentOutput0[];
    gates: ComponentGate1[];
    nets: number[];
    hash: string;
    repo: string;
    name: string;
    version: string;
}
export interface ComponentInput0 {
    readonly x: number;
    readonly y: number;
    readonly dx: number;
    readonly dy: number;
    readonly net: number;
    readonly pointsTo: ComponentInputPointer0[];
    readonly name?: string;
}
export interface ComponentInputPointer0 {
    readonly input: 'A' | 'B';
    readonly index: number;
}
export interface ComponentOutput0 {
    readonly x: number;
    readonly y: number;
    readonly net: number;
    readonly dx: number;
    readonly dy: number;
    readonly name?: string;
}
export interface ComponentGate1 {
    net: number;
    inputA: number;
    inputB: number;
}
export interface Component2 {
    readonly type: 'component';
    readonly schema: 2;
    readonly inputs: ComponentInput0[];
    readonly outputs: ComponentOutput0[];
    readonly gates: ComponentGate2[];
    readonly net: number;
    readonly hash: string;
    readonly repo: string;
    readonly name: string;
    readonly version: string;
}
export declare type ComponentGate2 = Readonly<[number, number]>;
export default function upgradeComponent(component: Component | Component2 | Component1 | Component0, size: {
    width: number;
    height: number;
}): Component;
//# sourceMappingURL=component.d.ts.map