"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = clear;

var _newArrowCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/newArrowCheck"));

var ennea = _interopRequireWildcard(require("ennea-tree"));

var _buddyTree = require("buddy-tree");

var _constants = require("../constants");

var _floodFill = require("../flooding/floodFill");

function clear(forest, x, y) {
  var _this = this;

  var _ennea$clear = ennea.clear(forest.enneaTree, {
    left: x,
    top: y
  }),
      enneaTree = _ennea$clear.tree,
      cleared = _ennea$clear.cleared;

  enneaTree = (0, _floodFill.floodFillGround)(enneaTree, cleared.map(function (c) {
    (0, _newArrowCheck2["default"])(this, _this);
    return [c.data, c];
  }.bind(this)));
  var buddyTree = cleared.map(getNetSource).filter(function (net) {
    (0, _newArrowCheck2["default"])(this, _this);
    return net > 1;
  }.bind(this)).reduce(_buddyTree.deallocate, forest.buddyTree);
  return {
    enneaTree: enneaTree,
    buddyTree: buddyTree
  };
}

function getNetSource(box) {
  if (box.data == null) {
    return -1;
  }

  switch (box.data.type) {
    case _constants.GATE:
    case _constants.BUTTON:
    case _constants.COMPONENT:
      return box.data.net;

    default:
      return -1;
  }
}
//# sourceMappingURL=clear.js.map