"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = createForest;
exports.createEnneaTree = createEnneaTree;
exports.createBuddyTree = createBuddyTree;

var ennea = _interopRequireWildcard(require("ennea-tree"));

var buddy = _interopRequireWildcard(require("buddy-tree"));

function createForest() {
  var buddyTree = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : createBuddyTree();
  var enneaTree = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : createEnneaTree();
  return {
    enneaTree: enneaTree,
    buddyTree: buddyTree
  };
}

function createEnneaTree() {
  return ennea.createTree(128);
}

function createBuddyTree() {
  var tree = buddy.createTree(256 * 256);
  return buddy.allocate(tree, 2).tree;
}
//# sourceMappingURL=createForest.js.map