"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = drawButton;

var _buddyTree = require("buddy-tree");

var _constants = require("../constants");

var _getNeighbouringNets = require("../query/getNeighbouringNets");

var _insertItem = _interopRequireDefault(require("./insertItem"));

var _utils = require("../utils");

function drawButton(forest, x, y) {
  var direction = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : _constants.RIGHTWARDS;
  var dx = (0, _utils.directionToDx)(direction);
  var dy = (0, _utils.directionToDy)(direction);
  var neighbouringNet = (0, _getNeighbouringNets.getButtonNeighbouringNets)(forest.enneaTree, x, y, dx, dy);

  if (neighbouringNet !== _constants.GROUND) {
    return forest;
  }

  var _allocate = (0, _buddyTree.allocate)(forest.buddyTree),
      buddyTree = _allocate.tree,
      net = _allocate.address;

  var data = {
    type: _constants.BUTTON,
    net: net,
    direction: direction,
    name: ''
  };
  var box = {
    left: x - 1,
    top: y - 1,
    width: 3,
    height: 3
  };
  return (0, _insertItem["default"])(forest, buddyTree, data, box);
}
//# sourceMappingURL=drawButton.js.map