"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = drawGate;

var _buddyTree = require("buddy-tree");

var _constants = require("../constants");

var _getNetAt = _interopRequireDefault(require("../query/getNetAt"));

var _getNeighbouringNets = require("../query/getNeighbouringNets");

var _insertItem = _interopRequireDefault(require("./insertItem"));

function drawGate(forest, x, y) {
  var neighbouringNets = (0, _getNeighbouringNets.getGateNeighbouringNets)(forest.enneaTree, x, y);

  if (neighbouringNets.length === 1) {
    return forest;
  }

  var _allocate = (0, _buddyTree.allocate)(forest.buddyTree),
      buddyTree = _allocate.tree,
      net = _allocate.address;

  var data = {
    type: _constants.GATE,
    net: net,
    inputA: (0, _getNetAt["default"])(forest.enneaTree, x - 4, y - 1, -1, 0),
    inputB: (0, _getNetAt["default"])(forest.enneaTree, x - 4, y + 1, -1, 0)
  };
  var box = {
    left: x - 3,
    top: y - 1,
    width: 4,
    height: 3
  };
  return (0, _insertItem["default"])(forest, buddyTree, data, box);
}
//# sourceMappingURL=drawGate.js.map