"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = drawLight;

var _constants = require("../constants");

var _getNeighbouringNets = require("../query/getNeighbouringNets");

var _insertItem = _interopRequireDefault(require("./insertItem"));

var _utils = require("../utils");

function drawLight(forest, x, y) {
  var direction = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : _constants.RIGHTWARDS;
  var dx = (0, _utils.directionToDx)(direction);
  var dy = (0, _utils.directionToDy)(direction);
  var buddyTree = forest.buddyTree;
  var neighbouringNet = (0, _getNeighbouringNets.getLightNeighbouringNet)(forest.enneaTree, x, y, dx, dy);
  var net = neighbouringNet || _constants.GROUND;
  var data = {
    type: _constants.LIGHT,
    net: net,
    name: '',
    direction: direction
  };
  var box = {
    left: x - 1,
    top: y - 1,
    width: 3,
    height: 3
  };
  return (0, _insertItem["default"])(forest, buddyTree, data, box);
}
//# sourceMappingURL=drawLight.js.map