"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = drawUnderpass;

var _constants = require("../constants");

var _getNeighbouringNets = require("../query/getNeighbouringNets");

var _insertItem = _interopRequireDefault(require("./insertItem"));

function drawUnderpass(forest, x, y) {
  var buddyTree = forest.buddyTree;
  var neighbouringNets = (0, _getNeighbouringNets.getUnderpassNeighbouringNets)(forest.enneaTree, x, y);

  if (neighbouringNets.horizontal.length > 1 || neighbouringNets.vertical.length > 1) {
    return forest;
  }

  var net = neighbouringNets.horizontal[0] || _constants.GROUND;
  var data = {
    type: _constants.UNDERPASS,
    net: net
  };
  var box = {
    left: x,
    top: y
  };
  return (0, _insertItem["default"])(forest, buddyTree, data, box);
}
//# sourceMappingURL=drawUnderpass.js.map