"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = drawWire;
exports.makeWire = void 0;

var _newArrowCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/newArrowCheck"));

var _constants = require("../constants");

var _getNeighbouringNets = require("../query/getNeighbouringNets");

var _insertItem = _interopRequireDefault(require("./insertItem"));

var _this = void 0;

function drawWire(forest, x, y) {
  var buddyTree = forest.buddyTree;
  var neighbouringNets = (0, _getNeighbouringNets.getWireNeighbouringNets)(forest.enneaTree, x, y);

  if (neighbouringNets.length > 1) {
    return forest;
  }

  var net = neighbouringNets[0] || _constants.GROUND;
  var data = makeWire(net);
  var box = {
    left: x,
    top: y
  };
  return (0, _insertItem["default"])(forest, buddyTree, data, box);
}

var makeWire = function makeWire(net) {
  (0, _newArrowCheck2["default"])(this, _this);
  return {
    type: _constants.WIRE,
    net: net
  };
}.bind(void 0);

exports.makeWire = makeWire;
//# sourceMappingURL=drawWire.js.map