"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = component;

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _newArrowCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/newArrowCheck"));

var _makePos = _interopRequireDefault(require("./makePos"));

var _constants = require("../constants");

function component(oldComponent, pos, ctx, queue) {
  var _this = this;

  var inputIndex = oldComponent["package"].inputs.findIndex(function (pin) {
    (0, _newArrowCheck2["default"])(this, _this);
    return pin.x === pos.left && pin.y === pos.top;
  }.bind(this));

  if (inputIndex >= 0) {
    var input = oldComponent["package"].inputs[inputIndex];
    var pins = oldComponent["package"].inputs.filter(function (pin) {
      (0, _newArrowCheck2["default"])(this, _this);
      return pin.group === input.group;
    }.bind(this));

    if (ctx.net !== _constants.GROUND) {
      var group = oldComponent.inputs.find(function (_, index) {
        (0, _newArrowCheck2["default"])(this, _this);
        return index === input.group;
      }.bind(this));

      if (group && group.net !== _constants.GROUND && group.net !== ctx.net) {
        throw new Error();
      }
    }

    var inputs = oldComponent.inputs.map(function (pin, index) {
      (0, _newArrowCheck2["default"])(this, _this);
      return index === input.group ? Object.assign({}, pin, {
        input: ctx.net === _constants.GROUND ? -1 : pins.indexOf(input),
        net: ctx.net
      }) : pin;
    }.bind(this));
    queue.push.apply(queue, (0, _toConsumableArray2["default"])(pins.filter(function (pin) {
      (0, _newArrowCheck2["default"])(this, _this);
      return pin !== input;
    }.bind(this)).map(function (pin) {
      (0, _newArrowCheck2["default"])(this, _this);
      return (0, _makePos["default"])({
        top: ctx.pos.top + (pin.y - input.y),
        left: ctx.pos.left + (pin.x - input.x)
      }, ctx.net, pin.dx, pin.dy);
    }.bind(this))));
    return Object.assign({}, oldComponent, {
      inputs: inputs
    });
  }

  var outputIndex = oldComponent["package"].outputs.findIndex(function (pin) {
    (0, _newArrowCheck2["default"])(this, _this);
    return pin.x === pos.left && pin.y === pos.top;
  }.bind(this));

  if (outputIndex >= 0) {
    var pin = oldComponent["package"].outputs[outputIndex];
    var output = oldComponent.outputs[outputIndex];

    if (output.net !== _constants.GROUND && ctx.net === _constants.GROUND) {
      queue.push((0, _makePos["default"])(ctx.pos, output.net, pin.dx, pin.dy));
    } else if (output.net !== _constants.GROUND && ctx.net !== _constants.GROUND && output.net !== ctx.net) {
      throw new Error();
    }
  }

  return oldComponent;
}
//# sourceMappingURL=component.js.map