"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = floodFill;
exports.floodFillGround = floodFillGround;

var _newArrowCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/newArrowCheck"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _enneaTree = require("ennea-tree");

var _constants = require("../constants");

var _wire = _interopRequireDefault(require("./wire"));

var _gate = _interopRequireDefault(require("./gate"));

var _underpass = _interopRequireDefault(require("./underpass"));

var _button = _interopRequireDefault(require("./button"));

var _component = _interopRequireDefault(require("./component"));

var _light = _interopRequireDefault(require("./light"));

var _unchanged = _interopRequireDefault(require("./unchanged"));

var _make = require("./make");

function floodFill(_ref, item, pos) {
  var enneaTree = _ref.enneaTree,
      buddyTree = _ref.buddyTree;
  return {
    enneaTree: floodFillInternal(enneaTree, false, [item, pos]),
    buddyTree: buddyTree
  };
}

function floodFillGround(enenaTree, floodSources) {
  return floodFillInternal.apply(void 0, [enenaTree, true].concat((0, _toConsumableArray2["default"])(floodSources)));
}

function floodFillInternal(enneaTree) {
  var _this = this;

  var isGround = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

  for (var _len = arguments.length, floodSources = new Array(_len > 2 ? _len - 2 : 0), _key = 2; _key < _len; _key++) {
    floodSources[_key - 2] = arguments[_key];
  }

  var queue = (0, _toConsumableArray2["default"])((0, _make.makeFloodQueue)(isGround, floodSources));
  var updater = (0, _enneaTree.update)(enneaTree, function (old, ctx, pos) {
    (0, _newArrowCheck2["default"])(this, _this);

    switch (old.type) {
      case _constants.WIRE:
        return (0, _wire["default"])(old, pos, ctx, queue);

      case _constants.GATE:
        return (0, _gate["default"])(old, pos, ctx, queue);

      case _constants.UNDERPASS:
        return (0, _underpass["default"])(old, pos, ctx, queue);

      case _constants.BUTTON:
        return (0, _button["default"])(old, pos, ctx, queue);

      case _constants.COMPONENT:
        return (0, _component["default"])(old, pos, ctx, queue);

      case _constants.LIGHT:
        return (0, _light["default"])(old, pos, ctx, queue);

      default:
        return old;
    }
  }.bind(this), _unchanged["default"]);
  return updater.result(queue);
}
//# sourceMappingURL=floodFill.js.map