"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = light;

var _constants = require("../constants");

function light(oldLight, pos, ctx, queue) {
  var net = ctx.net;

  if (net === oldLight.net) {
    return oldLight;
  }

  var x = pos.left;
  var y = pos.top;
  var dx = ctx.pos.left - ctx.prev.left;
  var dy = ctx.pos.top - ctx.prev.top;

  switch (oldLight.direction) {
    case _constants.UPWARDS:
      return x === 1 && y === 2 && dx === 0 && dy === -1 ? Object.assign({}, oldLight, {
        net: net
      }) : oldLight;

    case _constants.DOWNWARDS:
      return x === 1 && y === 0 && dx === 0 && dy === 1 ? Object.assign({}, oldLight, {
        net: net
      }) : oldLight;

    case _constants.LEFTWARDS:
      return x === 2 && y === 1 && dx === -1 && dy === 0 ? Object.assign({}, oldLight, {
        net: net
      }) : oldLight;

    case _constants.RIGHTWARDS:
    default:
      return x === 0 && y === 1 && dx === 1 && dy === 0 ? Object.assign({}, oldLight, {
        net: net
      }) : oldLight;
  }
}
//# sourceMappingURL=light.js.map