"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.makeFloodQueue = makeFloodQueue;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _newArrowCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/newArrowCheck"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _constants = require("../constants");

var _makePos = _interopRequireDefault(require("./makePos"));

var _utils = require("../utils");

var _marked =
/*#__PURE__*/
_regenerator["default"].mark(makeFloodQueue);

function makeFloodQueue(isGround, sources) {
  var _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, _step$value, item, pos, dx, dy, _iteratorNormalCompletion2, _didIteratorError2, _iteratorError2, _iterator2, _step2, _step2$value, output, pin, _iteratorNormalCompletion3, _didIteratorError3, _iteratorError3, _loop, _iterator3, _step3;

  return _regenerator["default"].wrap(function makeFloodQueue$(_context2) {
    while (1) {
      switch (_context2.prev = _context2.next) {
        case 0:
          _iteratorNormalCompletion = true;
          _didIteratorError = false;
          _iteratorError = undefined;
          _context2.prev = 3;
          _iterator = sources[Symbol.iterator]();

        case 5:
          if (_iteratorNormalCompletion = (_step = _iterator.next()).done) {
            _context2.next = 91;
            break;
          }

          _step$value = (0, _slicedToArray2["default"])(_step.value, 2), item = _step$value[0], pos = _step$value[1];
          _context2.t0 = item.type;
          _context2.next = _context2.t0 === _constants.WIRE ? 10 : _context2.t0 === _constants.GATE ? 19 : _context2.t0 === _constants.UNDERPASS ? 22 : _context2.t0 === _constants.BUTTON ? 31 : _context2.t0 === _constants.COMPONENT ? 36 : 88;
          break;

        case 10:
          _context2.next = 12;
          return (0, _makePos["default"])({
            top: pos.top,
            left: pos.left
          }, isGround ? _constants.GROUND : item.net, 0, 1);

        case 12:
          _context2.next = 14;
          return (0, _makePos["default"])({
            top: pos.top,
            left: pos.left
          }, isGround ? _constants.GROUND : item.net, 1, 0);

        case 14:
          _context2.next = 16;
          return (0, _makePos["default"])({
            top: pos.top,
            left: pos.left
          }, isGround ? _constants.GROUND : item.net, 0, -1);

        case 16:
          _context2.next = 18;
          return (0, _makePos["default"])({
            top: pos.top,
            left: pos.left
          }, isGround ? _constants.GROUND : item.net, -1, 0);

        case 18:
          return _context2.abrupt("break", 88);

        case 19:
          _context2.next = 21;
          return (0, _makePos["default"])({
            top: pos.top + 1,
            left: pos.left + 3
          }, isGround ? _constants.GROUND : item.net, 1, 0);

        case 21:
          return _context2.abrupt("break", 88);

        case 22:
          _context2.next = 24;
          return (0, _makePos["default"])({
            top: pos.top,
            left: pos.left
          }, isGround ? _constants.GROUND : item.net, 1, 0);

        case 24:
          _context2.next = 26;
          return (0, _makePos["default"])({
            top: pos.top,
            left: pos.left
          }, isGround ? _constants.GROUND : item.net, -1, 0);

        case 26:
          _context2.next = 28;
          return (0, _makePos["default"])({
            top: pos.top,
            left: pos.left
          }, _constants.GROUND, 0, 1);

        case 28:
          _context2.next = 30;
          return (0, _makePos["default"])({
            top: pos.top,
            left: pos.left
          }, _constants.GROUND, 0, -1);

        case 30:
          return _context2.abrupt("break", 88);

        case 31:
          dx = (0, _utils.directionToDx)(item.direction);
          dy = (0, _utils.directionToDy)(item.direction);
          _context2.next = 35;
          return (0, _makePos["default"])({
            top: pos.top + 1 + dy,
            left: pos.left + 1 + dx
          }, isGround ? _constants.GROUND : item.net, dx, dy);

        case 35:
          return _context2.abrupt("break", 88);

        case 36:
          _iteratorNormalCompletion2 = true;
          _didIteratorError2 = false;
          _iteratorError2 = undefined;
          _context2.prev = 39;
          _iterator2 = (0, _utils.zip)(item.outputs, item["package"].outputs)[Symbol.iterator]();

        case 41:
          if (_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done) {
            _context2.next = 48;
            break;
          }

          _step2$value = (0, _slicedToArray2["default"])(_step2.value, 2), output = _step2$value[0], pin = _step2$value[1];
          _context2.next = 45;
          return (0, _makePos["default"])({
            top: pos.top + pin.y,
            left: pos.left + pin.x
          }, isGround ? _constants.GROUND : output.net, pin.dx, pin.dy);

        case 45:
          _iteratorNormalCompletion2 = true;
          _context2.next = 41;
          break;

        case 48:
          _context2.next = 54;
          break;

        case 50:
          _context2.prev = 50;
          _context2.t1 = _context2["catch"](39);
          _didIteratorError2 = true;
          _iteratorError2 = _context2.t1;

        case 54:
          _context2.prev = 54;
          _context2.prev = 55;

          if (!_iteratorNormalCompletion2 && _iterator2["return"] != null) {
            _iterator2["return"]();
          }

        case 57:
          _context2.prev = 57;

          if (!_didIteratorError2) {
            _context2.next = 60;
            break;
          }

          throw _iteratorError2;

        case 60:
          return _context2.finish(57);

        case 61:
          return _context2.finish(54);

        case 62:
          _iteratorNormalCompletion3 = true;
          _didIteratorError3 = false;
          _iteratorError3 = undefined;
          _context2.prev = 65;
          _loop =
          /*#__PURE__*/
          _regenerator["default"].mark(function _loop() {
            var _this = this;

            var pin, input;
            return _regenerator["default"].wrap(function _loop$(_context) {
              while (1) {
                switch (_context.prev = _context.next) {
                  case 0:
                    pin = _step3.value;
                    input = item.inputs[pin.group];

                    if (!(input.input !== item["package"].inputs.filter(function (input) {
                      (0, _newArrowCheck2["default"])(this, _this);
                      return input.group === pin.group;
                    }.bind(this)).indexOf(pin))) {
                      _context.next = 5;
                      break;
                    }

                    _context.next = 5;
                    return (0, _makePos["default"])({
                      top: pos.top + pin.y,
                      left: pos.left + pin.x
                    }, isGround ? _constants.GROUND : input.net, pin.dx, pin.dy);

                  case 5:
                  case "end":
                    return _context.stop();
                }
              }
            }, _loop, this);
          });
          _iterator3 = item["package"].inputs[Symbol.iterator]();

        case 68:
          if (_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done) {
            _context2.next = 73;
            break;
          }

          return _context2.delegateYield(_loop(), "t2", 70);

        case 70:
          _iteratorNormalCompletion3 = true;
          _context2.next = 68;
          break;

        case 73:
          _context2.next = 79;
          break;

        case 75:
          _context2.prev = 75;
          _context2.t3 = _context2["catch"](65);
          _didIteratorError3 = true;
          _iteratorError3 = _context2.t3;

        case 79:
          _context2.prev = 79;
          _context2.prev = 80;

          if (!_iteratorNormalCompletion3 && _iterator3["return"] != null) {
            _iterator3["return"]();
          }

        case 82:
          _context2.prev = 82;

          if (!_didIteratorError3) {
            _context2.next = 85;
            break;
          }

          throw _iteratorError3;

        case 85:
          return _context2.finish(82);

        case 86:
          return _context2.finish(79);

        case 87:
          return _context2.abrupt("break", 88);

        case 88:
          _iteratorNormalCompletion = true;
          _context2.next = 5;
          break;

        case 91:
          _context2.next = 97;
          break;

        case 93:
          _context2.prev = 93;
          _context2.t4 = _context2["catch"](3);
          _didIteratorError = true;
          _iteratorError = _context2.t4;

        case 97:
          _context2.prev = 97;
          _context2.prev = 98;

          if (!_iteratorNormalCompletion && _iterator["return"] != null) {
            _iterator["return"]();
          }

        case 100:
          _context2.prev = 100;

          if (!_didIteratorError) {
            _context2.next = 103;
            break;
          }

          throw _iteratorError;

        case 103:
          return _context2.finish(100);

        case 104:
          return _context2.finish(97);

        case 105:
        case "end":
          return _context2.stop();
      }
    }
  }, _marked, null, [[3, 93, 97, 105], [39, 50, 54, 62], [55,, 57, 61], [65, 75, 79, 87], [80,, 82, 86], [98,, 100, 104]]);
}
//# sourceMappingURL=make.js.map