"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = unchanged;

var _newArrowCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/newArrowCheck"));

var _constants = require("../constants");

function unchanged(before, after) {
  switch (before.type) {
    case _constants.WIRE:
      return wire(before, after);

    case _constants.GATE:
      return gate(before, after);

    case _constants.UNDERPASS:
      return underpass(before, after);

    case _constants.BUTTON:
      return button(before, after);

    case _constants.COMPONENT:
      return component(before, after);

    case _constants.LIGHT:
      return light(before, after);
  }
}

function wire(before, after) {
  return before.net === after.net;
}

function gate(before, after) {
  return before.inputA === after.inputA && before.inputB === after.inputB && before.net === after.net;
}

function underpass(before, after) {
  return before.net === after.net;
}

function button(before, after) {
  return before.net === after.net && before.direction === after.direction && before.name === after.name;
}

function light(before, after) {
  return before.net === after.net && before.direction === after.direction && before.name === after.name;
}

function component(before, after) {
  var _this = this;

  if (before["package"].name !== after["package"].name) return false;
  if (before["package"].hash !== after["package"].hash) return false;
  if (before.inputs !== after.inputs && !before.inputs.every(function (e, i) {
    (0, _newArrowCheck2["default"])(this, _this);
    return e.net === after.inputs[i].net;
  }.bind(this))) return false;
  return true;
}
//# sourceMappingURL=unchanged.js.map