"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = underpass;
exports.floodUnderpass = floodUnderpass;

var _makePos = _interopRequireDefault(require("./makePos"));

function underpass(oldUnderpass, pos, ctx, queue) {
  var _floodUnderpass = floodUnderpass(ctx, queue),
      dx = _floodUnderpass.dx,
      dy = _floodUnderpass.dy;

  if (dx === 0 && dy !== 0) {
    return oldUnderpass;
  }

  return Object.assign({}, oldUnderpass, {
    net: ctx.net
  });
}

function floodUnderpass(ctx, queue) {
  var dx = ctx.pos.left - ctx.prev.left;
  var dy = ctx.pos.top - ctx.prev.top;
  queue.push((0, _makePos["default"])(ctx.pos, ctx.net, dx, dy));
  return {
    dx: dx,
    dy: dy
  };
}
//# sourceMappingURL=underpass.js.map