"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = wire;
exports.floodWire = floodWire;

var _makePos = _interopRequireDefault(require("./makePos"));

function wire(oldWire, pos, ctx, queue) {
  if (oldWire.net === ctx.net) {
    return oldWire;
  }

  floodWire(ctx, queue);
  return Object.assign({}, oldWire, {
    net: ctx.net
  });
}

function floodWire(ctx, queue) {
  pushPosToChanges(queue, ctx, -1, 0);
  pushPosToChanges(queue, ctx, +1, 0);
  pushPosToChanges(queue, ctx, 0, -1);
  pushPosToChanges(queue, ctx, 0, +1);
}

function pushPosToChanges(queue, ctx, dx, dy) {
  if (ctx.pos.left + dx != ctx.prev.left || ctx.pos.top + dy != ctx.prev.top) {
    queue.push((0, _makePos["default"])(ctx.pos, ctx.net, dx, dy));
  }
}
//# sourceMappingURL=wire.js.map