"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = layoutPins;

var _newArrowCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/newArrowCheck"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

function layoutPins(sources, drains) {
  var _this = this;

  var sourcesUps = sources.filter(toDown);
  var sourcesLefts = sources.filter(toRight);
  var sourcesRights = sources.filter(toLeft);
  var sourcesDowns = sources.filter(toUp);
  var drainsUps = drains.filter(toUp);
  var drainsLefts = drains.filter(toLeft);
  var drainsRights = drains.filter(toRight);
  var drainsDowns = drains.filter(toDown);
  var ups = [].concat((0, _toConsumableArray2["default"])(sourcesUps), (0, _toConsumableArray2["default"])(drainsUps)).sort(byX);
  var lefts = [].concat((0, _toConsumableArray2["default"])(sourcesLefts), (0, _toConsumableArray2["default"])(drainsLefts)).sort(byY);
  var rights = [].concat((0, _toConsumableArray2["default"])(sourcesRights), (0, _toConsumableArray2["default"])(drainsRights)).sort(byY);
  var downs = [].concat((0, _toConsumableArray2["default"])(sourcesDowns), (0, _toConsumableArray2["default"])(drainsDowns)).sort(byX);
  var width = Math.max(3, ups.length * 2 + 1, downs.length * 2 + 1);
  var height = Math.max(3, lefts.length * 2 + 1, rights.length * 2 + 1);
  var inputs = sources.map(function (pin) {
    (0, _newArrowCheck2["default"])(this, _this);
    return Object.assign({}, pin, getPos(pin));
  }.bind(this));
  var outputs = drains.map(function (pin) {
    (0, _newArrowCheck2["default"])(this, _this);
    return Object.assign({}, pin, getPos(pin));
  }.bind(this));
  return {
    width: width,
    height: height,
    inputs: inputs,
    outputs: outputs
  };

  function getPos(pin) {
    var index = ups.indexOf(pin);

    if (index >= 0) {
      return {
        x: (width - 1 >> 1) - ups.length + index * 2 + 1,
        y: 0
      };
    }

    index = downs.indexOf(pin);

    if (index >= 0) {
      return {
        x: (width - 1 >> 1) - downs.length + index * 2 + 1,
        y: height - 1
      };
    }

    index = lefts.indexOf(pin);

    if (index >= 0) {
      return {
        x: 0,
        y: (height - 1 >> 1) - lefts.length + index * 2 + 1
      };
    }

    index = rights.indexOf(pin);

    if (index >= 0) {
      return {
        x: width - 1,
        y: (height - 1 >> 1) - rights.length + index * 2 + 1
      };
    }

    return {
      x: 0,
      y: 0
    };
  }
}

function toLeft(_ref) {
  var dx = _ref.dx,
      dy = _ref.dy;
  return dx === -1 && dy === 0;
}

function toRight(_ref2) {
  var dx = _ref2.dx,
      dy = _ref2.dy;
  return dx === 1 && dy === 0;
}

function toUp(_ref3) {
  var dx = _ref3.dx,
      dy = _ref3.dy;
  return dx === 0 && dy === -1;
}

function toDown(_ref4) {
  var dx = _ref4.dx,
      dy = _ref4.dy;
  return dx === 0 && dy === 1;
}

function byX(a, b) {
  return a.x - b.x;
}

function byY(a, b) {
  return a.y - b.y;
}
//# sourceMappingURL=layoutPins.js.map