"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getWireNeighbouringNets = getWireNeighbouringNets;
exports.getGateNeighbouringNets = getGateNeighbouringNets;
exports.getUnderpassNeighbouringNets = getUnderpassNeighbouringNets;
exports.getButtonNeighbouringNets = getButtonNeighbouringNets;
exports.getLightNeighbouringNet = getLightNeighbouringNet;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _newArrowCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/newArrowCheck"));

var _constants = require("../constants");

var _getNetAt = _interopRequireDefault(require("./getNetAt"));

var _marked =
/*#__PURE__*/
_regenerator["default"].mark(getLeftRightNet),
    _marked2 =
/*#__PURE__*/
_regenerator["default"].mark(getAboveBelowNet),
    _marked3 =
/*#__PURE__*/
_regenerator["default"].mark(getRightNet);

function getWireNeighbouringNets(enneaTree, x, y) {
  return unique(getLeftRightNet(enneaTree, x, y), getAboveBelowNet(enneaTree, x, y));
}

function getGateNeighbouringNets(enneaTree, x, y) {
  return unique(getRightNet(enneaTree, x, y));
}

function getUnderpassNeighbouringNets(enneaTree, x, y) {
  return {
    horizontal: unique(getLeftRightNet(enneaTree, x, y)),
    vertical: unique(getAboveBelowNet(enneaTree, x, y))
  };
}

function getButtonNeighbouringNets(enneaTree, x, y, dx, dy) {
  return (0, _getNetAt["default"])(enneaTree, x + dx * 2, y + dy * 2, dx, dy);
}

function getLightNeighbouringNet(enneaTree, x, y, dx, dy) {
  return (0, _getNetAt["default"])(enneaTree, x - dx * 2, y - dy * 2, -dx, -dy);
}

function unique() {
  var _this = this;

  for (var _len = arguments.length, iteratorA = new Array(_len), _key = 0; _key < _len; _key++) {
    iteratorA[_key] = arguments[_key];
  }

  return iteratorA.reduce(function (a, b) {
    (0, _newArrowCheck2["default"])(this, _this);
    return a.concat.apply(a, (0, _toConsumableArray2["default"])(b));
  }.bind(this), []).filter(function (net) {
    (0, _newArrowCheck2["default"])(this, _this);
    return net != _constants.GROUND;
  }.bind(this)).filter(function (net, index, nets) {
    (0, _newArrowCheck2["default"])(this, _this);
    return nets.indexOf(net) === index;
  }.bind(this));
}

function getLeftRightNet(enneaTree, x, y) {
  return _regenerator["default"].wrap(function getLeftRightNet$(_context) {
    while (1) {
      switch (_context.prev = _context.next) {
        case 0:
          _context.next = 2;
          return (0, _getNetAt["default"])(enneaTree, x - 1, y + 0, -1, 0);

        case 2:
          _context.next = 4;
          return (0, _getNetAt["default"])(enneaTree, x + 1, y + 0, +1, 0);

        case 4:
        case "end":
          return _context.stop();
      }
    }
  }, _marked);
}

function getAboveBelowNet(enneaTree, x, y) {
  return _regenerator["default"].wrap(function getAboveBelowNet$(_context2) {
    while (1) {
      switch (_context2.prev = _context2.next) {
        case 0:
          _context2.next = 2;
          return (0, _getNetAt["default"])(enneaTree, x + 0, y - 1, 0, -1);

        case 2:
          _context2.next = 4;
          return (0, _getNetAt["default"])(enneaTree, x + 0, y + 1, 0, +1);

        case 4:
        case "end":
          return _context2.stop();
      }
    }
  }, _marked2);
}

function getRightNet(enneaTree, x, y) {
  return _regenerator["default"].wrap(function getRightNet$(_context3) {
    while (1) {
      switch (_context3.prev = _context3.next) {
        case 0:
          _context3.next = 2;
          return (0, _getNetAt["default"])(enneaTree, x + 1, y + 0, +1, 0);

        case 2:
        case "end":
          return _context3.stop();
      }
    }
  }, _marked3);
}
//# sourceMappingURL=getNeighbouringNets.js.map