"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = clear;
exports.clearArea = clearArea;
exports.clearGate = clearGate;
exports.clearComponent = clearComponent;

var _newArrowCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/newArrowCheck"));

var _tileConstants = require("./tileConstants");

var _constants = require("../constants");

function clear(context, change) {
  clearArea(context, change);

  switch (change.before.type) {
    case _constants.WIRE:
    case _constants.UNDERPASS:
      return;

    case _constants.GATE:
    case _constants.BUTTON:
      return clearGate(context, change.before);

    case _constants.COMPONENT:
      return clearComponent(context, change.before);
  }
}

function clearArea(context, _ref) {
  var top = _ref.top,
      left = _ref.left,
      width = _ref.width,
      height = _ref.height;

  for (var y = top; y < top + height; y++) {
    for (var x = left; x < left + width; x++) {
      context.setMap(x, y, _tileConstants.EMPTY_TILE);
      context.setNet(x, y, _constants.GROUND);
    }
  }
}

function clearGate(context, item) {
  context.clearGate(item.net);
}

function clearComponent(context, component) {
  var _this = this;

  context.removeText(component);
  var _iteratorNormalCompletion = true;
  var _didIteratorError = false;
  var _iteratorError = undefined;

  try {
    for (var _iterator = component["package"].gates.map(function (_, index) {
      (0, _newArrowCheck2["default"])(this, _this);
      return index;
    }.bind(this))[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
      var index = _step.value;
      context.clearGate(component.net + index);
    }
  } catch (err) {
    _didIteratorError = true;
    _iteratorError = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion && _iterator["return"] != null) {
        _iterator["return"]();
      }
    } finally {
      if (_didIteratorError) {
        throw _iteratorError;
      }
    }
  }
}
//# sourceMappingURL=clear.js.map