"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = reconcile;
exports.reconcileChange = reconcileChange;

var _enneaTree = require("ennea-tree");

var _set = _interopRequireDefault(require("./set"));

var _update = _interopRequireDefault(require("./update"));

var _clear = _interopRequireDefault(require("./clear"));

function reconcile(context, changes) {
  var changed = false;
  var _iteratorNormalCompletion = true;
  var _didIteratorError = false;
  var _iteratorError = undefined;

  try {
    for (var _iterator = changes[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
      var change = _step.value;
      changed = true;
      reconcileChange(context, change);
    }
  } catch (err) {
    _didIteratorError = true;
    _iteratorError = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion && _iterator["return"] != null) {
        _iterator["return"]();
      }
    } finally {
      if (_didIteratorError) {
        throw _iteratorError;
      }
    }
  }

  return changed;
}

function reconcileChange(context, change) {
  switch (change.type) {
    case _enneaTree.SET:
      return (0, _set["default"])(context, change);

    case _enneaTree.CLEAR:
      return (0, _clear["default"])(context, change);

    case _enneaTree.UPDATE:
      if (change.before.type === change.after.type) {
        return (0, _update["default"])(context, change);
      } else {
        (0, _clear["default"])(context, Object.assign({}, change, {
          type: _enneaTree.CLEAR
        }));
        (0, _set["default"])(context, Object.assign({}, change, {
          type: _enneaTree.SET
        }));
      }

  }
}
//# sourceMappingURL=reconcile.js.map