"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.wire = wire;
exports.underpass = underpass;
exports.gate = gate;
exports.button = button;
exports.light = light;
exports.component = component;
exports.buttonOutput = buttonOutput;
exports.lightInput = lightInput;

var _newArrowCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/newArrowCheck"));

var _tileConstants = require("./tileConstants");

function wire() {
  return _tileConstants.WIRE_TILE;
}

function underpass() {
  return _tileConstants.UNDERPASS_TILE;
}

function gate(x, y) {
  return _tileConstants.GATE_TILE + (0, _tileConstants.tile)(x, y);
}

function button(x, y) {
  return _tileConstants.BUTTON_TILE + (0, _tileConstants.tile)(x, y);
}

function light(x, y) {
  return _tileConstants.LIGHT_TILE + (0, _tileConstants.tile)(x, y);
}

function component(x, y, w, h, ports) {
  var _this = this;

  if (x === 0) {
    if (y === 0) {
      return _tileConstants.COMPONENT_TILE + (0, _tileConstants.tile)(0, 0);
    } else if (y === h) {
      return _tileConstants.COMPONENT_TILE + (0, _tileConstants.tile)(0, 3);
    } else if (ports.some(function (p) {
      (0, _newArrowCheck2["default"])(this, _this);
      return p.x === x && p.y === y;
    }.bind(this))) {
      return _tileConstants.COMPONENT_TILE + (0, _tileConstants.tile)(0, 1);
    } else {
      return _tileConstants.COMPONENT_TILE + (0, _tileConstants.tile)(0, 2);
    }
  } else if (x === w) {
    if (y === 0) {
      return _tileConstants.COMPONENT_TILE + (0, _tileConstants.tile)(3, 0);
    } else if (y === h) {
      return _tileConstants.COMPONENT_TILE + (0, _tileConstants.tile)(3, 3);
    } else if (ports.some(function (p) {
      (0, _newArrowCheck2["default"])(this, _this);
      return p.x === x && p.y === y;
    }.bind(this))) {
      return _tileConstants.COMPONENT_TILE + (0, _tileConstants.tile)(3, 2);
    } else {
      return _tileConstants.COMPONENT_TILE + (0, _tileConstants.tile)(3, 1);
    }
  } else {
    if (y === 0) {
      if (ports.some(function (p) {
        (0, _newArrowCheck2["default"])(this, _this);
        return p.x === x && p.y === y;
      }.bind(this))) {
        return _tileConstants.COMPONENT_TILE + (0, _tileConstants.tile)(2, 0);
      } else {
        return _tileConstants.COMPONENT_TILE + (0, _tileConstants.tile)(1, 0);
      }
    } else if (y === h) {
      if (ports.some(function (p) {
        (0, _newArrowCheck2["default"])(this, _this);
        return p.x === x && p.y === y;
      }.bind(this))) {
        return _tileConstants.COMPONENT_TILE + (0, _tileConstants.tile)(1, 3);
      } else {
        return _tileConstants.COMPONENT_TILE + (0, _tileConstants.tile)(2, 3);
      }
    } else {
      return _tileConstants.COMPONENT_TILE + (0, _tileConstants.tile)(1, 1);
    }
  }
}

function buttonOutput(dx, dy) {
  if (dx === 0) {
    if (dy === 1) {
      return _tileConstants.BUTTON_OUTPUT_TILE + (0, _tileConstants.tile)(1, 0);
    } else {
      return _tileConstants.BUTTON_OUTPUT_TILE + (0, _tileConstants.tile)(3, 0);
    }
  } else {
    if (dx === 1) {
      return _tileConstants.BUTTON_OUTPUT_TILE + (0, _tileConstants.tile)(0, 0);
    } else {
      return _tileConstants.BUTTON_OUTPUT_TILE + (0, _tileConstants.tile)(2, 0);
    }
  }
}

function lightInput(dx, dy) {
  if (dx === 0) {
    if (dy === 1) {
      return _tileConstants.LIGHT_INPUT_TILE + (0, _tileConstants.tile)(3, 0);
    } else {
      return _tileConstants.LIGHT_INPUT_TILE + (0, _tileConstants.tile)(1, 0);
    }
  } else {
    if (dx === 1) {
      return _tileConstants.LIGHT_INPUT_TILE + (0, _tileConstants.tile)(2, 0);
    } else {
      return _tileConstants.LIGHT_INPUT_TILE + (0, _tileConstants.tile)(0, 0);
    }
  }
}
//# sourceMappingURL=tile.js.map