"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = upgradeComponent;

var _newArrowCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/newArrowCheck"));

function upgradeComponent(component, size) {
  return from2to3(from1to2(from0to1(component)), size.width, size.height);
}

function from0to1(component) {
  if (component.schema === undefined) {
    return {
      type: 'component',
      schema: 1,
      inputs: component.inputs,
      outputs: component.outputs,
      gates: component.gates,
      nets: component.nets,
      name: component.name || 'unknown',
      repo: '',
      version: '0',
      hash: '0000000000000000000000000000000000000000'
    };
  } else {
    return component;
  }
}

function from1to2(component) {
  var _this = this;

  if (component.schema === 1) {
    return {
      type: 'component',
      schema: 2,
      inputs: component.inputs,
      outputs: component.outputs,
      gates: component.gates.map(function (_ref) {
        var inputA = _ref.inputA,
            inputB = _ref.inputB;
        (0, _newArrowCheck2["default"])(this, _this);
        return [inputA, inputB];
      }.bind(this)),
      net: component.nets[0],
      name: component.name,
      repo: component.repo,
      version: component.version,
      hash: component.hash
    };
  } else {
    return component;
  }
}

function from2to3(component, width, height) {
  var _this2 = this;

  if (component.schema === 2) {
    return {
      type: 'component',
      schema: 3,
      net: component.net,
      inputs: component.inputs.map(function (input) {
        (0, _newArrowCheck2["default"])(this, _this2);
        return {
          name: input.name,
          net: input.net,
          input: 0
        };
      }.bind(this)),
      outputs: component.outputs.map(function (output) {
        (0, _newArrowCheck2["default"])(this, _this2);
        return {
          name: output.name,
          net: output.net
        };
      }.bind(this)),
      "package": {
        hash: component.hash,
        name: component.name,
        repo: component.repo,
        version: component.version,
        height: height,
        width: width,
        inputs: component.inputs.map(function (input, index) {
          (0, _newArrowCheck2["default"])(this, _this2);
          return {
            x: input.x,
            y: input.y,
            dx: input.dx,
            dy: input.dy,
            group: index
          };
        }.bind(this)),
        outputs: component.outputs.map(function (output) {
          (0, _newArrowCheck2["default"])(this, _this2);
          return {
            x: output.x,
            y: output.y,
            dx: output.dx,
            dy: output.dy,
            name: output.name || '',
            gate: output.net - component.net
          };
        }.bind(this)),
        gates: component.gates.map(function (gate) {
          (0, _newArrowCheck2["default"])(this, _this2);
          return [gate[0] < component.net ? 'GROUND' : gate[0] - component.net, gate[1] < component.net ? 'GROUND' : gate[1] - component.net];
        }.bind(this)),
        groups: component.inputs.map(function (input) {
          var _this3 = this;

          (0, _newArrowCheck2["default"])(this, _this2);
          return {
            name: input.name || '',
            pointsTo: input.pointsTo.map(function (point) {
              (0, _newArrowCheck2["default"])(this, _this3);
              return {
                gate: point.index,
                input: point.input
              };
            }.bind(this))
          };
        }.bind(this))
      }
    };
  } else {
    return component;
  }
}
//# sourceMappingURL=component.js.map