"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.directionToDx = directionToDx;
exports.directionToDy = directionToDy;
exports.zip = zip;
exports.flatten = flatten;
exports.distinct = distinct;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _constants = require("./constants");

var _marked =
/*#__PURE__*/
_regenerator["default"].mark(zip);

function directionToDx(direction) {
  switch (direction) {
    case _constants.LEFTWARDS:
      return -1;

    case _constants.RIGHTWARDS:
      return 1;

    case _constants.DOWNWARDS:
    case _constants.UPWARDS:
    default:
      return 0;
  }
}

function directionToDy(direction) {
  switch (direction) {
    case _constants.DOWNWARDS:
      return 1;

    case _constants.UPWARDS:
      return -1;

    case _constants.LEFTWARDS:
    case _constants.RIGHTWARDS:
    default:
      return 0;
  }
}

function zip(a, b) {
  var i;
  return _regenerator["default"].wrap(function zip$(_context) {
    while (1) {
      switch (_context.prev = _context.next) {
        case 0:
          i = 0;

        case 1:
          if (!(i < a.length)) {
            _context.next = 7;
            break;
          }

          _context.next = 4;
          return [a[i], b[i], i];

        case 4:
          i++;
          _context.next = 1;
          break;

        case 7:
        case "end":
          return _context.stop();
      }
    }
  }, _marked);
}

function flatten() {
  var a = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
  var b = arguments.length > 1 ? arguments[1] : undefined;
  return a.concat(b);
}

function distinct(e, i, c) {
  return c.indexOf(e) === i;
}
//# sourceMappingURL=utils.js.map